//------------------------------------------------------------------------------
/*
    This file is part of Bottle2D.

    Bottle2D is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bottle2D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bottle2D.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include "Utils.hpp"

#include "MyException.hpp"
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
namespace En
{
//------------------------------------------------------------------------------
void Sound::LoadFromFile(const std::string &filename)
{
    if(!sf::SoundBuffer::LoadFromFile(filename))
    {
        MY_THROW("Error: Can't load sound '" << filename << "' !");
    }
}
//------------------------------------------------------------------------------
void Texture::LoadFromFile(const std::string &filename)
{
    if(!sf::Image::LoadFromFile(filename))
    {
        MY_THROW("Error: Can't load texture '" << filename << "' !");
    }
}
//------------------------------------------------------------------------------
void Music::LoadFromFile(const std::string &filename)
{
    if(!sf::Music::OpenFromFile(filename))
    {
        MY_THROW("Error: Can't load music '" << filename << "' !");
    }
}
//------------------------------------------------------------------------------
bool Music::IsPlaying() const
{
    return sf::Music::GetStatus() == sf::Music::Playing;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void Font::LoadFromFile(const std::string &filename)
{
    if(!sf::Font::LoadFromFile(filename))
    {
        MY_THROW("Error: Can't load font '" << filename << "' !");
    }
}
//------------------------------------------------------------------------------
sf::Unicode::UTF8String StrToSfUtf8(const std::string &str)
{
	return sf::Unicode::UTF8String(reinterpret_cast<const unsigned char*>(str.c_str()));
}
//------------------------------------------------------------------------------
} // namespace En
