//------------------------------------------------------------------------------
/*
    This file is part of Bottle2D.

    Bottle2D is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bottle2D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bottle2D.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include "glUtils.hpp"

#include <iostream>

#include "MyException.hpp"
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
namespace En
{
//------------------------------------------------------------------------------
using namespace std;
//------------------------------------------------------------------------------
void EnableOpenGLCut(const sf::FloatRect &rect, sf::RenderTarget &App)
{
    // View rect coords
    sf::FloatRect viewRect = App.GetView().GetRect();

    // Transform local coordonates to window coordonates
    sf::FloatRect windowRect;
    windowRect.Left = (rect.Left - viewRect.Left) / viewRect.GetWidth() * App.GetWidth();
    windowRect.Top = (rect.Top - viewRect.Top) / viewRect.GetHeight() * App.GetHeight();
    windowRect.Right = (rect.Right - viewRect.Left) / viewRect.GetWidth() * App.GetWidth();
    windowRect.Bottom = (rect.Bottom - viewRect.Top) / viewRect.GetHeight() * App.GetHeight();

    // Change Y origine and active GL cut
    glEnable(GL_SCISSOR_TEST);
    glScissor(windowRect.Left, App.GetHeight() - windowRect.GetHeight() - windowRect.Top, windowRect.GetWidth(), windowRect.GetHeight());
}
//------------------------------------------------------------------------------
void DisableOpenGLCut()
{
    glDisable(GL_SCISSOR_TEST);
}
//------------------------------------------------------------------------------
} // namespace En
